--[[ InfiniteTools by tehMugwump
Moderately Friendly Update

Description:

This mod makes your common tools and staffs last forever. 
------------------------------------------------------------------------------
To install this mod, put this file in a new folder under
".\mods" called "InfiniteTools",

When you run the game you should see a screen pop up that lists this mod as being loaded.

--]]

PrefabFiles = {
	"trap",
	"shovel",
	"pickaxe",
	"mininglantern",
	"blowdart",
	"axe",
	"staff",

}
-- prevents torch from burning
local function preventBurn (inst)
    inst.components.fueled.DoDelta = function () end -- set to blank function
    inst.components.fueled.GetPercent = function () return 1 end
end
AddPrefabPostInit("torch", preventBurn )
--
function preventPerishable (inst)
    inst.components.perishable.Update = function () end -- set to blank function
    inst.components.perishable.GetPercent = function () return 1 end
end

AddPrefabPostInit("pumpkin_lantern", preventPerishable )

function InfiniteTools_RemoveFiniteUses(inst)
	if inst.components.finiteuses then
		inst:RemoveComponent("finiteuses")
	end
end


function InfiniteTools_StaffFiniteUses(inst) --has no effect when implimented
	if staff.components.finiteuses then
		inst:RemoveComponent("finiteuses")
	end
end

--inst:AddComponent("fueled")
function InfiniteTools_Removefueled(inst)
	if inst.components.fueled then
		inst:RemoveComponent("fueled")
	end
end


--OnSleep event of tent which caused game to crash.
function InfiniteTools_DisableUses(inst)

	local function EatUse(self, num)
    	--Do nothing
	end

	if inst.components.finiteuses then
		inst.components.finiteuses.Use = EatUse
	end

end
--inst:AddComponent("perish")
function InfiniteTools_RemovePerishable(inst)
	
	if inst.components.perishable then
		inst:RemoveComponent("perishable")
	end
end
--increases Torch light radius
TORCH_RADIUS = 5	--Default: 2 (meters)
local function torchfirePrefabPostInit(inst)
	if inst and inst.Light then
		inst.Light:SetRadius( TORCH_RADIUS )
	end
end
AddPrefabPostInit("torchfire", torchfirePrefabPostInit)


--Comment out any of the lines below to disable this change if desired
--AddPrefabPostInit("staff", InfiniteTools_RemoveFiniteUses)
AddPrefabPostInit("axe", InfiniteTools_RemoveFiniteUses)
AddPrefabPostInit("birdtrap", InfiniteTools_RemoveFiniteUses)
AddPrefabPostInit("boomerang", InfiniteTools_RemoveFiniteUses)
AddPrefabPostInit("bugnet", InfiniteTools_RemoveFiniteUses)
AddPrefabPostInit("fishingrod", InfiniteTools_RemoveFiniteUses)
AddPrefabPostInit("hambat", InfiniteTools_RemoveFiniteUses)
AddPrefabPostInit("hammer", InfiniteTools_RemoveFiniteUses)
AddPrefabPostInit("horn", InfiniteTools_RemoveFiniteUses) --Beefalo horn

AddPrefabPostInit("nightsword", InfiniteTools_RemoveFiniteUses)
AddPrefabPostInit("panflute", InfiniteTools_RemoveFiniteUses)
AddPrefabPostInit("pickaxe", InfiniteTools_RemoveFiniteUses)
AddPrefabPostInit("pitchfork", InfiniteTools_RemoveFiniteUses)
AddPrefabPostInit("shovel", InfiniteTools_RemoveFiniteUses)
AddPrefabPostInit("spear", InfiniteTools_RemoveFiniteUses)
AddPrefabPostInit("tentaclespike", InfiniteTools_RemoveFiniteUses)
AddPrefabPostInit("trap_teeth", InfiniteTools_RemoveFiniteUses)
AddPrefabPostInit("trunk", InfiniteTools_RemoveFiniteUses)
AddPrefabPostInit("umbrella", InfiniteTools_RemoveFiniteUses)
AddPrefabPostInit("batbat", InfiniteTools_RemoveFiniteUses)

--Staffs



--Gold subsets
AddPrefabPostInit("goldenaxe", InfiniteTools_RemoveFiniteUses)
AddPrefabPostInit("goldenpickaxe", InfiniteTools_RemoveFiniteUses)
AddPrefabPostInit("goldenshovel", InfiniteTools_RemoveFiniteUses)

--misc
AddPrefabPostInit("tent", InfiniteTools_DisableUses)

AddPrefabPostInit("sewingkit", InfiniteTools_RemoveFiniteUses)

--blow dart file
